<?php

##################################################
#
# Copyright (c) 2004-2005 James Hunt and the OIC Group, Inc.
#
# This file is part of Exponent
#
# Exponent is free software; you can redistribute
# it and/or modify it under the terms of the GNU
# General Public License as published by the Free
# Software Foundation; either version 2 of the
# License, or (at your option) any later version.
#
# Exponent is distributed in the hope that it
# will be useful, but WITHOUT ANY WARRANTY;
# without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR
# PURPOSE.  See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU
# General Public License along with Exponent; if
# not, write to:
#
# Free Software Foundation, Inc.,
# 59 Temple Place,
# Suite 330,
# Boston, MA 02111-1307  USA
#
# $Id: bbmodule_config.php,v 1.3 2005/02/19 16:53:23 filetreefrog Exp $
##################################################

class bbmodule_config {
	function form($object) {
		if (!defined("SYS_FORMS")) include_once(BASE."subsystems/forms.php");
		pathos_forms_initialize();
		
		$form = new form();
		if (!isset($object->id)) {
			$object->email_title_thread = "Exponent Forum : New Thread Posted";
			$object->email_title_reply =  "Exponent Forum : New Reply Posted";
			
			$object->email_from_thread = "Forum Manager <forum@".$_SERVER['HTTP_HOST'].">";
			$object->email_from_reply  = "Forum Manager <forum@".$_SERVER['HTTP_HOST'].">";
			
			$object->email_address_thread = "forum@".$_SERVER['HTTP_HOST'];
			$object->email_address_reply  = "forum@".$_SERVER['HTTP_HOST'];
			
			$object->email_reply_thread = "forum@".$_SERVER['HTTP_HOST'];
			$object->email_reply_reply  = "forum@".$_SERVER['HTTP_HOST'];
			
			$object->email_showpost_thread = 0;
			$object->email_showpost_reply  = 0;
			
			$object->email_signature = "--\nThanks, Webmaster";
		} else {
			$form->meta("id",$object->id);
		}
		
		$form->register(uniqid(""),"",new htmlcontrol("<hr size='1' />'New Thread' Email"));
		$form->register("email_title_thread","Message Title",new textcontrol($object->email_title_thread));
		$form->register("email_from_thread","From (Display)",new textcontrol($object->email_from_thread));
		$form->register("email_address_thread","From (Email)",new textcontrol($object->email_address_thread));
		$form->register("email_reply_thread","Reply-to",new textcontrol($object->email_reply_thread));
		$form->register("email_showpost_thread","Show post in message?",new checkboxcontrol($object->email_showpost_thread,true));
		
		$form->register(uniqid(""),"",new htmlcontrol("<hr size='1' />'New Reply' Email"));
		$form->register("email_title_reply","Message Title",new textcontrol($object->email_title_reply));
		$form->register("email_from_reply","From (Display)",new textcontrol($object->email_from_reply));
		$form->register("email_address_reply","From (Email)",new textcontrol($object->email_address_reply));
		$form->register("email_reply_reply","Reply-to",new textcontrol($object->email_reply_reply));
		$form->register("email_showpost_reply","Show post in message?",new checkboxcontrol($object->email_showpost_reply,true));
		
		$form->register(uniqid(""),"",new htmlcontrol("<hr size='1' />General Settings (applies to both email message types)"));
		$form->register("email_signature","Email Signature",new texteditorcontrol($object->email_signature,5,30));
		
		$form->register("submit","",new buttongroupcontrol("Save","","Cancel"));
		
		pathos_forms_cleanup();
		return $form;
	}
	
	function update($values,$object) {
		$object->email_title_thread = $values['email_title_thread'];
		$object->email_from_thread = $values['email_from_thread'];
		$object->email_address_thread = $values['email_address_thread'];
		$object->email_reply_thread = $values['email_reply_thread'];
		$object->email_showpost_thread = (isset($values['email_showpost_thread']) ? 1 : 0);
		
		$object->email_title_reply = $values['email_title_reply'];
		$object->email_from_reply = $values['email_from_reply'];
		$object->email_address_reply = $values['email_address_reply'];
		$object->email_reply_reply = $values['email_reply_reply'];
		$object->email_showpost_reply = (isset($values['email_showpost_reply']) ? 1 : 0);
		
		$object->email_signature = $values['email_signature'];
		return $object;
	}
}

?>